<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/localFlash/localFlash.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_957949500aeb3cfa450c783906d3c101.html">localFlash</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">localFlash.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">IEEE</span>;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="vhdlkeyword">use </span>IEEE.STD_LOGIC_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="vhdlkeyword">use </span>work.localFlash_IO.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_misc.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno"><a class="code" href="classlocalFlash.html">    8</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classlocalFlash.html">localFlash</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;  </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;  <span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="vhdlchar">clk_40Mhz</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>    <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    <span class="vhdlchar">SCL</span>       <span class="vhdlchar">:</span> <span class="vhdlkeyword">inout</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="vhdlchar">SDA</span>       <span class="vhdlchar">:</span> <span class="vhdlkeyword">inout</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="vhdlchar">monitor</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">localFlash_monitor_t</span>;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="vhdlchar">control</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="vhdlchar">localFlash_control_t</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">entity</span> <span class="vhdlchar">localFlash</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div>
<div class="line"><a name="l00019"></a><span class="lineno"><a class="code" href="classlocalFlash_1_1behavior.html">   19</a></span>&#160;<span class="vhdlkeyword">architecture</span> behavior <span class="vhdlkeyword">of</span> <a class="code" href="classlocalFlash.html">localFlash</a> is</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classI2C__reg__master.html">I2C_reg_master</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="vhdlkeyword">generic</span> (</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;      I2C_QUARTER_PERIOD_CLOCK_COUNT : <span class="comment">integer</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;      IGNORE_ACK                     : <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;      REG_ADDR_BYTE_COUNT            : <span class="comment">integer</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;      USE_RESTART_FOR_READ_SEQUENCE  : <span class="comment">std_logic</span>);</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;      clk_sys     : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;      reset       : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;      I2C_Address : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">6</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;      run         : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;      rw          : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      reg_addr    : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic_vector</span>((REG_ADDR_BYTE_COUNT*<span class="vhdllogic"></span><span class="vhdllogic">8</span>)<span class="keyword"> -</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;      rd_data     : <span class="vhdlkeyword">out</span>   <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;      wr_data     : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;      byte_count  : <span class="vhdlkeyword">in</span>    <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">2</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;      done        : <span class="vhdlkeyword">out</span>   <span class="comment">std_logic</span> := &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;      error       : <span class="vhdlkeyword">out</span>   <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;      SDA         : <span class="vhdlkeyword">inout</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;      SCLK        : <span class="vhdlkeyword">inout</span> <span class="comment">std_logic</span>);</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">I2C_reg_master</span>;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="vhdlkeyword">begin</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">addr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">addr</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">wr_data</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">wr_data</span>;</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">reset</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">reset</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;  <span class="vhdlchar">monitor</span><span class="vhdlchar">.</span><span class="vhdlchar">rw</span>    <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">control</span><span class="vhdlchar">.</span><span class="vhdlchar">rw</span>;  </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;  I2C_reg_master_1: <span class="vhdlkeyword">entity</span> work.<a class="code" href="classI2C__reg__master.html">I2C_reg_master</a></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      I2C_QUARTER_PERIOD_CLOCK_COUNT  =&gt; <span class="vhdllogic">20</span>,</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;      REG_ADDR_BYTE_COUNT             =&gt; <span class="vhdllogic">2</span><span class="vhdlchar">)</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;      clk_sys      =&gt; clk_40Mhz,</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      reset        =&gt; control.reset ,</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;      I2C_Address  =&gt; &quot;<span class="vhdllogic">1010000</span>&quot;,</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;      run          =&gt; control.run ,</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;      rw           =&gt; control.rw ,</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;      reg_addr     =&gt; control.addr ,</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;      rd_data      =&gt; monitor.rd_data ,</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;      wr_data      =&gt; control.wr_data ,</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;      byte_count   =&gt; &quot;<span class="vhdllogic">100</span>&quot;,</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;      done         =&gt; monitor.done ,</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;      error        =&gt; monitor.error ,</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;      SDA          =&gt; SDA,</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;      SCLK         =&gt; SCL<span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">behavior</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:31 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
